﻿using UnityEngine;
using System.Collections;

public class AtmosphereMaterialColoring : AtmosphereColorEnforcer
{

	public string colorTag = "_MainColor";

	[Range (0, 1)]
	public float alphaOveride;

	public bool hasAlphaOveride;




	private Material _myMaterial;

	private Material myMaterial {
		get {
			if (_myMaterial == null)
				_myMaterial = myRenderer.sharedMaterial;
			return _myMaterial;
		}   
		set {
			_myMaterial = value;
		}
	}


	public override void UpdateColorSettings ()
	{
		base.UpdateColorSettings ();

		if (hasAlphaOveride)
			resultColor.a = alphaOveride;

		myMaterial.SetColor (colorTag, resultColor);
		//myLight.color = resultColor;
	}


	private Renderer _myRenderer;

	private Renderer myRenderer {
		get {
			if (_myRenderer == null)
				_myRenderer = GetComponent<Renderer> ();
			return _myRenderer;
		}   
		set {
			_myRenderer = value;
		}
	}

}
