﻿using UnityEngine;
using System.Collections;

public class AtmosphereReflectionColorEnforcer : AtmosphereColorEnforcer
{
	[Range (0, 1)]
	public float alphaOveride;

	public bool hasAlphaOveride;

	public override void UpdateColorSettings ()
	{
		base.UpdateColorSettings ();
		if (hasAlphaOveride)
			resultColor.a = alphaOveride;
		myRenderer.sharedMaterial.SetColor ("_ReflectionColor", resultColor);
	}

	private Renderer _myRenderer;

	private Renderer myRenderer {
		get {
			if (_myRenderer == null)
				_myRenderer = GetComponent<Renderer> ();
			return _myRenderer;
		}   
		set {
			_myRenderer = value;
		}
	}


}
