﻿using UnityEngine;
using UnityStandardAssets.ImageEffects;
using System.Collections;
using System.Collections.Generic;


[System.Serializable , CreateAssetMenu (menuName = "Another Circus/Eviormental Style")]
public class EviormentalStyle : ScriptableObject
{

	public float transitionSmoothnes = 0.1f;

	[Header ("Background Settings")]
	public Color fogColor;
	public float fogStartDistance;
	public float fogEndDistance;

	[Header ("Sky Colors")]
	public Color horizonStartColor;
	public Color horizonEndColor;

	[Header ("Clouds")]
	public Color cloudColor;
	public float cloudAmount;
	public float cloudSpeed;


	public Color cloudColor2;
	public float cloudAmount2;
	public float cloudSpeed2;


	[Header ("Sea Settings")]
	public Color seaDeepColor;
	public Color seaShallowColor;
	public Color seaSideColor;
	public Color seaEdgeColor;
	public Color seaFoamColor;
	public float seaEmisionAmount;
	[Range (0, 50)]
	public float seaDepthBalance;

	[Header ("Mountain Settings")]
	public float mountainSpecMix;
	public Color mountainSpecColor;
	public Color mountainColorFront;
	public Color mountainColorSide;

	[Header ("SUN Settings")]
	public Color sunColor;
	[Range (0, 10)]
	public float sunIntensity;

	public Vector3 sunRotation;

	[Header ("SunShafts Settings")]
	public Color sunShaftThreshold;
	public Color sunShaftColor;



	[Header ("Gloss Settings")]
	public Color glossColor = new Color (0.5f, 0.5f, 0.5f);
	public float glossAmount = 0.485f;


	[Header ("Boat Reflection Color")]
	public Color color1 = Color.white;
	[Header ("Light 1 Color")]
	public Color color2 = Color.white;
	[Header ("Trail & Foam Color")]
	public Color color3 = Color.white;
	[Header ("Var 1 Color")]
	public Color color4 = Color.white;
	[Header ("Light 2 Color")]
	public Color color5 = Color.white;





}	