// Upgrade NOTE: replaced '_Object2World' with 'unity_ObjectToWorld'

// Shader created with Shader Forge v1.28 
// Shader Forge (c) Neat Corporation / Joachim Holmer - http://www.acegikmo.com/shaderforge/
// Note: Manually altering this data may prevent you from opening it in Shader Forge
/*SF_DATA;ver:1.28;sub:START;pass:START;ps:flbk:,iptp:0,cusa:False,bamd:0,lico:1,lgpr:1,limd:1,spmd:1,trmd:0,grmd:0,uamb:True,mssp:True,bkdf:False,hqlp:False,rprd:False,enco:False,rmgx:True,rpth:0,vtps:0,hqsc:True,nrmq:1,nrsp:0,vomd:0,spxs:False,tesm:0,olmd:1,culm:0,bsrc:3,bdst:7,dpts:2,wrdp:False,dith:0,rfrpo:True,rfrpn:Refraction,coma:15,ufog:True,aust:True,igpj:True,qofs:0,qpre:3,rntp:2,fgom:False,fgoc:False,fgod:False,fgor:False,fgmd:0,fgcr:0.5,fgcg:0.5,fgcb:0.5,fgca:1,fgde:0.01,fgrn:0,fgrf:300,stcl:False,stva:128,stmr:255,stmw:255,stcp:6,stps:0,stfa:0,stfz:0,ofsf:0,ofsu:0,f2p0:False,fnsp:False,fnfb:False;n:type:ShaderForge.SFN_Final,id:4013,x:32719,y:32712,varname:node_4013,prsc:2|diff-2090-OUT,emission-2090-OUT,alpha-9408-OUT;n:type:ShaderForge.SFN_TexCoord,id:2011,x:31313,y:32536,varname:node_2011,prsc:2,uv:0;n:type:ShaderForge.SFN_Lerp,id:1625,x:32184,y:32491,varname:node_1625,prsc:2|A-5069-RGB,B-3782-RGB,T-2858-OUT;n:type:ShaderForge.SFN_Color,id:5069,x:31717,y:32089,ptovrint:False,ptlb:Deep Water,ptin:_DeepWater,varname:node_5069,prsc:2,glob:False,taghide:False,taghdr:False,tagprd:False,tagnsco:False,tagnrm:False,c1:0,c2:0,c3:0,c4:1;n:type:ShaderForge.SFN_Color,id:3782,x:31817,y:32364,ptovrint:False,ptlb:Shallow Water,ptin:_ShallowWater,varname:node_3782,prsc:2,glob:False,taghide:False,taghdr:False,tagprd:False,tagnsco:False,tagnrm:False,c1:1,c2:1,c3:1,c4:0;n:type:ShaderForge.SFN_Slider,id:3683,x:31677,y:32967,ptovrint:False,ptlb:Slider1,ptin:_Slider1,varname:node_3683,prsc:2,glob:False,taghide:False,taghdr:False,tagprd:False,tagnsco:False,tagnrm:False,min:-1,cur:0,max:1;n:type:ShaderForge.SFN_Add,id:2858,x:31850,y:32646,varname:node_2858,prsc:2|A-70-OUT,B-3683-OUT;n:type:ShaderForge.SFN_Lerp,id:9408,x:32291,y:32788,varname:node_9408,prsc:2|A-5069-A,B-3782-A,T-2858-OUT;n:type:ShaderForge.SFN_Multiply,id:2090,x:32442,y:32347,varname:node_2090,prsc:2|A-6052-RGB,B-1625-OUT;n:type:ShaderForge.SFN_Tex2d,id:6052,x:32184,y:32250,ptovrint:False,ptlb:Ray Texture,ptin:_RayTexture,varname:node_6052,prsc:2,glob:False,taghide:False,taghdr:False,tagprd:False,tagnsco:False,tagnrm:False,ntxv:0,isnm:False|UVIN-5862-UVOUT;n:type:ShaderForge.SFN_Time,id:9257,x:31773,y:31877,varname:node_9257,prsc:2;n:type:ShaderForge.SFN_Panner,id:9633,x:32054,y:31568,varname:node_9633,prsc:2,spu:1,spv:0|UVIN-5378-UVOUT,DIST-96-OUT;n:type:ShaderForge.SFN_Panner,id:5862,x:32383,y:31753,varname:node_5862,prsc:2,spu:0,spv:1|UVIN-9633-UVOUT,DIST-7478-OUT;n:type:ShaderForge.SFN_Slider,id:3306,x:31591,y:31627,ptovrint:False,ptlb:Pan X,ptin:_PanX,varname:node_3306,prsc:2,glob:False,taghide:False,taghdr:False,tagprd:False,tagnsco:False,tagnrm:False,min:-1,cur:0,max:1;n:type:ShaderForge.SFN_TexCoord,id:5378,x:31756,y:31333,varname:node_5378,prsc:2,uv:0;n:type:ShaderForge.SFN_Multiply,id:96,x:31908,y:31693,varname:node_96,prsc:2|A-3306-OUT,B-9257-T;n:type:ShaderForge.SFN_Multiply,id:7478,x:32146,y:31834,varname:node_7478,prsc:2|A-9257-T,B-8141-OUT;n:type:ShaderForge.SFN_Slider,id:8141,x:32022,y:32098,ptovrint:False,ptlb:Pan Y,ptin:_PanY,varname:_PanX_copy,prsc:2,glob:False,taghide:False,taghdr:False,tagprd:False,tagnsco:False,tagnrm:False,min:-1,cur:0,max:1;n:type:ShaderForge.SFN_OneMinus,id:931,x:31037,y:32813,varname:node_931,prsc:2|IN-7749-OUT;n:type:ShaderForge.SFN_RemapRange,id:7749,x:30782,y:32717,varname:node_7749,prsc:2,frmn:0,frmx:1,tomn:1,tomx:0|IN-2011-V;n:type:ShaderForge.SFN_Multiply,id:3762,x:31326,y:32722,varname:node_3762,prsc:2|A-7749-OUT,B-931-OUT;n:type:ShaderForge.SFN_RemapRange,id:70,x:31517,y:32722,varname:node_70,prsc:2,frmn:0.5,frmx:0,tomn:2,tomx:0|IN-3762-OUT;proporder:5069-3782-3683-6052-3306-8141;pass:END;sub:END;*/

Shader "Another Circus/Water Rays" {
    Properties {
        _DeepWater ("Deep Water", Color) = (0,0,0,1)
        _ShallowWater ("Shallow Water", Color) = (1,1,1,0)
        _Slider1 ("Slider1", Range(-1, 1)) = 0
        _RayTexture ("Ray Texture", 2D) = "white" {}
        _PanX ("Pan X", Range(-1, 1)) = 0
        _PanY ("Pan Y", Range(-1, 1)) = 0
        [HideInInspector]_Cutoff ("Alpha cutoff", Range(0,1)) = 0.5
    }
    SubShader {
        Tags {
            "IgnoreProjector"="True"
            "Queue"="Transparent"
            "RenderType"="Transparent"
        }
        Pass {
            Name "FORWARD"
            Tags {
                "LightMode"="ForwardBase"
            }
            Blend SrcAlpha OneMinusSrcAlpha
            ZWrite Off
            
            CGPROGRAM
            #pragma vertex vert
            #pragma fragment frag
            #define UNITY_PASS_FORWARDBASE
            #include "UnityCG.cginc"
            #pragma multi_compile_fwdbase
            #pragma multi_compile_fog
            #pragma exclude_renderers d3d11_9x xbox360 xboxone ps3 ps4 psp2 
            #pragma target 3.0
            uniform float4 _LightColor0;
            uniform float4 _TimeEditor;
            uniform float4 _DeepWater;
            uniform float4 _ShallowWater;
            uniform float _Slider1;
            uniform sampler2D _RayTexture; uniform float4 _RayTexture_ST;
            uniform float _PanX;
            uniform float _PanY;
            struct VertexInput {
                float4 vertex : POSITION;
                float3 normal : NORMAL;
                float2 texcoord0 : TEXCOORD0;
            };
            struct VertexOutput {
                float4 pos : SV_POSITION;
                float2 uv0 : TEXCOORD0;
                float4 posWorld : TEXCOORD1;
                float3 normalDir : TEXCOORD2;
                UNITY_FOG_COORDS(3)
            };
            VertexOutput vert (VertexInput v) {
                VertexOutput o = (VertexOutput)0;
                o.uv0 = v.texcoord0;
                o.normalDir = UnityObjectToWorldNormal(v.normal);
                o.posWorld = mul(unity_ObjectToWorld, v.vertex);
                float3 lightColor = _LightColor0.rgb;
                o.pos = mul(UNITY_MATRIX_MVP, v.vertex );
                UNITY_TRANSFER_FOG(o,o.pos);
                return o;
            }
            float4 frag(VertexOutput i) : COLOR {
                i.normalDir = normalize(i.normalDir);
                float3 normalDirection = i.normalDir;
                float3 lightDirection = normalize(_WorldSpaceLightPos0.xyz);
                float3 lightColor = _LightColor0.rgb;
////// Lighting:
                float attenuation = 1;
                float3 attenColor = attenuation * _LightColor0.xyz;
/////// Diffuse:
                float NdotL = max(0.0,dot( normalDirection, lightDirection ));
                float3 directDiffuse = max( 0.0, NdotL) * attenColor;
                float3 indirectDiffuse = float3(0,0,0);
                indirectDiffuse += UNITY_LIGHTMODEL_AMBIENT.rgb; // Ambient Light
                float4 node_9257 = _Time + _TimeEditor;
                float2 node_5862 = ((i.uv0+(_PanX*node_9257.g)*float2(1,0))+(node_9257.g*_PanY)*float2(0,1));
                float4 _RayTexture_var = tex2D(_RayTexture,TRANSFORM_TEX(node_5862, _RayTexture));
                float node_7749 = (i.uv0.g*-1.0+1.0);
                float node_931 = (1.0 - node_7749);
                float3 node_2090 = (_RayTexture_var.rgb*lerp(_DeepWater.rgb,_ShallowWater.rgb,(((node_7749*node_931)*4.0+0.0)+_Slider1)));
                float3 diffuseColor = node_2090;
                float3 diffuse = (directDiffuse + indirectDiffuse) * diffuseColor;
////// Emissive:
                float3 emissive = node_2090;
/// Final Color:
                float3 finalColor = diffuse + emissive;
                float node_9408 = lerp(_DeepWater.a,_ShallowWater.a,(((node_7749*node_931)*4.0+0.0)+_Slider1));
                fixed4 finalRGBA = fixed4(finalColor,node_9408);
                UNITY_APPLY_FOG(i.fogCoord, finalRGBA);
                return finalRGBA;
            }
            ENDCG
        }
        Pass {
            Name "FORWARD_DELTA"
            Tags {
                "LightMode"="ForwardAdd"
            }
            Blend One One
            ZWrite Off
            
            CGPROGRAM
            #pragma vertex vert
            #pragma fragment frag
            #define UNITY_PASS_FORWARDADD
            #include "UnityCG.cginc"
            #include "AutoLight.cginc"
            #pragma multi_compile_fwdadd
            #pragma multi_compile_fog
            #pragma exclude_renderers d3d11_9x xbox360 xboxone ps3 ps4 psp2 
            #pragma target 3.0
            uniform float4 _LightColor0;
            uniform float4 _TimeEditor;
            uniform float4 _DeepWater;
            uniform float4 _ShallowWater;
            uniform float _Slider1;
            uniform sampler2D _RayTexture; uniform float4 _RayTexture_ST;
            uniform float _PanX;
            uniform float _PanY;
            struct VertexInput {
                float4 vertex : POSITION;
                float3 normal : NORMAL;
                float2 texcoord0 : TEXCOORD0;
            };
            struct VertexOutput {
                float4 pos : SV_POSITION;
                float2 uv0 : TEXCOORD0;
                float4 posWorld : TEXCOORD1;
                float3 normalDir : TEXCOORD2;
                LIGHTING_COORDS(3,4)
                UNITY_FOG_COORDS(5)
            };
            VertexOutput vert (VertexInput v) {
                VertexOutput o = (VertexOutput)0;
                o.uv0 = v.texcoord0;
                o.normalDir = UnityObjectToWorldNormal(v.normal);
                o.posWorld = mul(unity_ObjectToWorld, v.vertex);
                float3 lightColor = _LightColor0.rgb;
                o.pos = mul(UNITY_MATRIX_MVP, v.vertex );
                UNITY_TRANSFER_FOG(o,o.pos);
                TRANSFER_VERTEX_TO_FRAGMENT(o)
                return o;
            }
            float4 frag(VertexOutput i) : COLOR {
                i.normalDir = normalize(i.normalDir);
                float3 normalDirection = i.normalDir;
                float3 lightDirection = normalize(lerp(_WorldSpaceLightPos0.xyz, _WorldSpaceLightPos0.xyz - i.posWorld.xyz,_WorldSpaceLightPos0.w));
                float3 lightColor = _LightColor0.rgb;
////// Lighting:
                float attenuation = LIGHT_ATTENUATION(i);
                float3 attenColor = attenuation * _LightColor0.xyz;
/////// Diffuse:
                float NdotL = max(0.0,dot( normalDirection, lightDirection ));
                float3 directDiffuse = max( 0.0, NdotL) * attenColor;
                float4 node_9257 = _Time + _TimeEditor;
                float2 node_5862 = ((i.uv0+(_PanX*node_9257.g)*float2(1,0))+(node_9257.g*_PanY)*float2(0,1));
                float4 _RayTexture_var = tex2D(_RayTexture,TRANSFORM_TEX(node_5862, _RayTexture));
                float node_7749 = (i.uv0.g*-1.0+1.0);
                float node_931 = (1.0 - node_7749);
                float3 node_2090 = (_RayTexture_var.rgb*lerp(_DeepWater.rgb,_ShallowWater.rgb,(((node_7749*node_931)*4.0+0.0)+_Slider1)));
                float3 diffuseColor = node_2090;
                float3 diffuse = directDiffuse * diffuseColor;
/// Final Color:
                float3 finalColor = diffuse;
                float node_9408 = lerp(_DeepWater.a,_ShallowWater.a,(((node_7749*node_931)*4.0+0.0)+_Slider1));
                fixed4 finalRGBA = fixed4(finalColor * node_9408,0);
                UNITY_APPLY_FOG(i.fogCoord, finalRGBA);
                return finalRGBA;
            }
            ENDCG
        }
    }
    FallBack "Diffuse"
    CustomEditor "ShaderForgeMaterialInspector"
}
