﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class SceneryObject : MonoBehaviour
{
	public float startMoveSpeed;
	public float moveSpeed;
	public float resetValue;

	public float minPos;
	public float maxPos;


	public float sizeRandomizer;

	public float zposTracePos;

	public float yOffset;

	public Vector3 startSize;

	// Use this for initialization
	void Start ()
	{
		startSize = myTransform.localScale;
		ResetItems ();
	}
	
	// Update is called once per frame
	void FixedUpdate ()
	{
		float ypos = OceanHandler.instance.GetHeight (new Vector3 (myTransform.position.x, myTransform.position.y, zposTracePos), true, false) + yOffset;
		myTransform.position = new Vector3 (myTransform.position.x - moveSpeed, ypos, myTransform.position.z);
		if (myTransform.position.x < resetValue)
			ResetItems ();
	}


	public void ResetItems ()
	{

		float z = Random.Range (minPos, maxPos);

		float percSpeed = Mathf.InverseLerp (minPos, maxPos, z);

		moveSpeed = startMoveSpeed * (0.5f + percSpeed);

		float ypos = OceanHandler.instance.GetHeight (new Vector3 (myTransform.position.x, myTransform.position.y, zposTracePos), true, false);

		myTransform.position = new Vector3 (30, ypos, z);

		myTransform.localScale = startSize * (1 + Random.Range (-sizeRandomizer, sizeRandomizer));

	}

	private Transform _myTransform;

	private Transform myTransform {
		get {
			if (_myTransform == null)
				_myTransform = GetComponent<Transform> ();
			return _myTransform;
		}

		set {
			_myTransform = value;
		}

	}


}
