﻿using UnityEngine;
using AudioSystem;
using System.Collections;

namespace AudioSystem
{
		[System.Serializable]
		/// <summary>
		/// Audio data class contain nessecery information for Sound file in the project
		/// </summary>
		public class AudioClass : System.IEquatable <string>
		{
				/// <summary>
				/// The audio file identifier.
				/// </summary>
				public string id;
				/// <summary>
				/// The audio clip.
				/// </summary>
				public AudioClip audioClip;

				[Range (0, 2)]
				/// <summary>
				/// The audio file play volume.
				/// </summary>
				public float
						volume = 1;

				[HideInInspector]
				public bool
						isOpen = false;


				public AudioClass (AudioClip audio_clip)
				{
						this.audioClip = audio_clip;
						this.id = audio_clip.name;
				}

				public bool Equals (string _id)
				{
						if (this.id == _id) {
								return true;
						} else {
								return false;
						}
				}
		}
}