﻿using UnityEngine;
using System.Collections;
using AudioSystem;

public class PlaySoundTask : TaskHandler
{
	public float soundDelay;
	public string SfxID;



	public override void EnableTask ()
	{
		base.EnableTask ();
		Debug.Log (string.Format ("{1} : PlaySoundTask - EnableTask : {0}", this.name, Time.time));
		StartCoroutine (PlaySFX ());
		SendTaskCompleted ();
	}


	public void OnTriggerEnter (Collider other)
	{
		Debug.Log (string.Format ("PlaySoundTask - OnTriggerEnter : {0}", other.tag));
		if (other.tag != "Player")
			return;

		StartCoroutine (PlaySFX ());
	}



	IEnumerator PlaySFX ()
	{
		yield return new WaitForSeconds (soundDelay);
		AudioManager.PlaySfx (SfxID, soundDelay);
	}


}