﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic;

public static class HRUtilities
{
			
	/* ---------   Default Values  ---------*/
	public static float at = 0.35f;
	public static EaseType dE = EaseType.QuadInOut;

	public static Color fA = new Color (1, 1, 1, 0);
	public static Color fC = new Color (1, 1, 1, 1);
	public static Color fO = new Color (1, 1, 1, 0.7f);

	public static float ft = 5f;
	
	public static int defaultScore = 100;
	
	public static float maxWinDistance = 0.35f;

	public static float colliderDragScale = 15f;
		
	public static float topStatusTime = 3f;

	public static float screenWidth = 960f;
	public static float screenHeight = 0;
	// 540f;

	/* ---------   Event Function ---------*/
	public const string EnableTask = "EnableTask";
	public const string TaskCompleted = "TaskCompleted";

	public const string EnableObjective = "EnableObjective";
	public const string ObjectiveCompleted = "ObjectiveCompleted";
	public const string DisableObjective = "DisableObjective";

	public const string RemoveEvents = "RemoveEvents";
	public const string FixEvents = "FixEvents";
		
	public const string AddScore = "AddScore";
	public const string RemoveScore = "RemoveScore";
	public const string ResetScore = "ResetScore";
	public const string AddDisplayScore = "AddDisplayScore";

	public const string OnHover = "OnHover";
	public const string OnHout = "OnHout";

	public const string FreezePhysics = "FreezePhysics";
	public const string UnFreezePhysics = "UnFreezePhysics";
			
	/* --------- Utility Functions ---------*/

	public static  Vector3 GetMousePosition (Camera aCamera = null)
	{
		Ray ray;
		if (aCamera) {
			ray = aCamera.ScreenPointToRay (Input.mousePosition);
			return ray.origin;
		} else if (Camera.main) {
			ray = Camera.main.ScreenPointToRay (Input.mousePosition);
			return ray.origin;
		} 
		Debug.Log ("GetMousePosition: NO CAMERA FOUND!");
		return Vector3.zero;
			
	}

	public static Vector3 GetMousePositionFromPoint (Camera aCamera = null)
	{
		Vector3 mousePos;

		if (aCamera)
			mousePos = aCamera.ScreenToWorldPoint (new Vector3 (Input.mousePosition.x, Input.mousePosition.y, aCamera.farClipPlane - 1));
		else
			mousePos = Camera.main.ScreenToWorldPoint (new Vector3 (Input.mousePosition.x, Input.mousePosition.y, Camera.main.farClipPlane - 1));

		return mousePos;	 
	}


	public static float Distance2D (Vector3 a, Vector3 b)
	{
		return Mathf.Sqrt (Mathf.Pow (a.x - b.x, 2) + Mathf.Pow (a.y - b.y, 2));
	}


	public static float Custom2dAngle (float x1, float y1, float x2, float y2)
	{
		float Radians;
		float Degrees;
		Radians = Mathf.Atan2 ((y1 - y2), (x1 - x2));
		Degrees = Radians * 180 / Mathf.PI;
		return Degrees;
	}

	// adjust a Vector3 by a rotation , position or scale
	public static Vector3 ConvertVector (Vector3 source, Quaternion rotate, Vector3 move, Vector3 scale)
	{
		Matrix4x4 m = Matrix4x4.TRS (move, rotate, scale); 
		Vector3 result = m.MultiplyPoint3x4 (source);
		return result;
	}




	public static float ClampAngle (float angle)
	{
		if (angle > 180)
			angle = angle - 360;
		if (angle < -180)
			angle = angle + 360;
		return angle;
	}

	public static float Color01 (float value)
	{
		return value / 255f;
	}

	public static Color Color01 (float r, float b, float g)
	{
		return new Color (HRUtilities.Color01 (r), HRUtilities.Color01 (b), HRUtilities.Color01 (g));
	}

}
