﻿using UnityEngine;
using AudioSystem;
using System.Collections;
using System.Collections.Generic;

public class ObjectiveEnabler : TaskHandler
{

	[Header ("Main Settings")]

	public bool
		singleChoice = false;
	
	public bool removeEvents = true;

	public bool oneItemCorrect = false;
	public int correctID = 0;

	public List<GameObject> Objectives;

	public List<GameObject> extraObjectives;

	 	

	public override void EnableTask ()
	{
		enableObjectives ();
	}

	public void enableObjectives ()
	{
		//Debug.Log (string.Format ("ObjectiveEnabler - enableObjectives ({0}) ", name));
		for (int i = 0; i < Objectives.Count; i++)
			Objectives [i].SendMessage (HRUtilities.EnableObjective);
		for (int i = 0; i < extraObjectives.Count; i++)
			extraObjectives [i].SendMessage (HRUtilities.EnableObjective);
	}

	public virtual void ObjectiveCompleted (GameObject goItem)
	{
		//		Debug.Log (string.Format ("ObjectiveEnabler - ObjectiveCompleted ({0}) ", goItem));

		if (removeEvents)
			goItem.SendMessage (HRUtilities.RemoveEvents, SendMessageOptions.DontRequireReceiver);
				
		if (singleChoice) {
			TaskComplete ();
			return;
		}

		if (!oneItemCorrect) {
			Objectives.Remove (goItem);
			Debug.Log (string.Format ("Objectives.Count : {0}", Objectives.Count));	
			if (Objectives.Count == 0)
				TaskComplete ();
		} else {
			int id = Objectives.IndexOf (goItem);
			if (correctID == id)
				TaskComplete ();
			else
				myTransform.parent.SendMessageUpwards (HRUtilities.RemoveScore, SendMessageOptions.DontRequireReceiver);
		}
	
	}




	public void TaskComplete ()
	{
		//Debug.Log (string.Format ("ObjectiveEnabler - TaskComplete ({0}) ", name));
		//SendMessageUpwards (HRUtilities.TaskCompleted, gameObject, SendMessageOptions.DontRequireReceiver);
				
		if (removeEvents) {
			for (int i = 0; i < Objectives.Count; i++)
				Objectives [i].SendMessage (HRUtilities.RemoveEvents);

			for (int i = 0; i < extraObjectives.Count; i++) {
				extraObjectives [i].SendMessage (HRUtilities.ObjectiveCompleted, SendMessageOptions.DontRequireReceiver);
				extraObjectives [i].SendMessage (HRUtilities.DisableObjective, SendMessageOptions.DontRequireReceiver);
				extraObjectives [i].SendMessage (HRUtilities.RemoveEvents, SendMessageOptions.DontRequireReceiver);
			}
		}

		SendTaskCompleted ();
	}


	private Transform _myTransform;

	public Transform myTransform {
		get {
			if (_myTransform == null)
				_myTransform = GetComponent<Transform> ();
			return _myTransform;
		}
		
		set {
			_myTransform = value;
		}
		
	}

}