﻿using UnityEngine;
using AudioSystem;
using System.Collections;

/// <summary>
/// Simple tool that Fade's in a list of GameObjects
/// </summary>
public class FadeInList : MonoBehaviour
{
	public GameObject[] ObjectList;

	public void Awake ()
	{
		for (int i = 0; i < ObjectList.Length; i++)
			ObjectList [i].GetComponent<SpriteRenderer> ().color = HRUtilities.fA;
	}

	public void EnableObjective ()
	{
		StartCoroutine (AnimateList ());
	}

	IEnumerator AnimateList ()
	{
		for (int i = 0; i < ObjectList.Length; i++) {
			StartCoroutine (ObjectList [i].GetComponent<SpriteRenderer> ().FadeAlphaTime (1, HRUtilities.at, EaseType.Linear));
			yield return StartCoroutine (Auto.Wait (HRUtilities.at / 4));
		}
	}



}