﻿using UnityEngine;
using System.Collections;
using UnityEngine.Events;
using UnityEngine.EventSystems;

public class ObjectDrag : TaskHandler
{

	[Header ("Touch Settings")]
	public bool mouseIsDown;
	public Vector2 touchPos;

	[Header ("Physics Settings")]
	public float dragpower;
	public ForceMode forcemode;
	// Use this for initialization

	public override void OnPointerDown (PointerEventData eventData)
	{
		Debug.Log (string.Format ("eventData.name : {0}", eventData.rawPointerPress));
		mouseIsDown = true;
		Debug.Log (string.Format ("OnPointerDown ()"));
	}



	public override void OnPointerUp (PointerEventData eventData)
	{
		mouseIsDown = false;
		Debug.Log (string.Format ("OnPointerUp ()"));
	}



	void Start ()
	{
	
	}
	
	// Update is called once per frame
	void FixedUpdate ()
	{
	

		if (mouseIsDown) {			
			touchPos = Input.mousePosition;
			Vector3 worldPos = Camera.main.ScreenToWorldPoint (new Vector3 (touchPos.x, touchPos.y, myTransform.position.z - Camera.main.transform.position.z));
			Debug.DrawRay (worldPos, Vector3.up * 2, Color.red, 0.5f);

			float inputDiff = worldPos.x - myTransform.position.x;
			Vector2 touchDiff = new Vector2 (inputDiff, 0);
			myRigidbody.AddForce (touchDiff * dragpower, forcemode); 





		}

	}


	private Transform _myTransform;

	private Transform myTransform {
		get {
			if (_myTransform == null)
				_myTransform = GetComponent<Transform> ();
			return _myTransform;
		}

		set {
			_myTransform = value;
		}

	}

	private Rigidbody _myRigidbody;

	private Rigidbody myRigidbody {
		get {
			if (_myRigidbody == null)
				_myRigidbody = GetComponent<Rigidbody> ();
			return _myRigidbody;
		}   
		set {
			_myRigidbody = value;
		}
	}

}
