﻿using UnityEngine;
using System.Collections;

public class NoiseMovement : MonoBehaviour
{

	public bool useLocalAxis = false;
	public bool floatOnWater = false;

	[Space (5)]
	public float movementAmount;
	public float speed;

	[Space (5)]
	public Vector3 startPos;

	private float timePositioningRandomizer;
	private float timeKeeper;


	void Start ()
	{
		if (useLocalAxis)
			startPos = myTransform.localPosition;
		else
			startPos = myTransform.position;

		timePositioningRandomizer = Random.Range (0, 1000);
	}
	
	// Update is called once per frame
	void FixedUpdate ()
	{
		timeKeeper = (Time.time * speed) + timePositioningRandomizer;
		float xpos = (0.5f - Mathf.PerlinNoise (timeKeeper, 0f)) * movementAmount;

		float ypos;

		ypos = (0.5f - Mathf.PerlinNoise (timeKeeper, 100f)) * movementAmount;

		float zpos = (0.5f - Mathf.PerlinNoise (timeKeeper, 1000f)) * movementAmount;


		Vector3 addPos = new Vector3 (xpos, ypos, zpos);

		if (useLocalAxis)
			myTransform.localPosition = startPos + addPos;
		else
			myTransform.position = startPos + addPos;
	}


	private Transform _myTransform;

	private Transform myTransform {
		get {
			if (_myTransform == null)
				_myTransform = GetComponent<Transform> ();
			return _myTransform;
		}

		set {
			_myTransform = value;
		}

	}


}
