﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class BoencyHandler : MonoBehaviour
{

	public float rotMulty;

	public float weightResult;
	public float otherHitsVal;

	public List<PlayerControl> objectsInContact = new List<PlayerControl> ();

	[Header ("Diveing SEttings")]
	public float divingMultiplyer;
	public Transform frontDivingPoint;
	public Transform backDivingPoint;


	// Use this for initialization
	void Start ()
	{
		//StartCoroutine (EndFrameClearWeight ());
	}
	
	// Update is called once per frame
	void FixedUpdate ()
	{
		/*
		Collider[] testColliders = Physics.OverlapBox (transform.position, box.bounds.size / 2, Quaternion.Euler (new Vector3 ()), playerLayer);
		Debug.Log ("Found " + testColliders.Length + " collisions");
		for (int i = 0; i < testColliders.Length; i++) {
			Debug.Log ("Name " + testColliders [i].gameObject.name);
		}
		*/
		weightResult = 0;
		for (int i = 0; i < objectsInContact.Count; i++) {

			if (objectsInContact [i].grounded) {
				float diff = (myTransform.position.x - objectsInContact [i].myRigidbody2D.position.x) * objectsInContact [i].myRigidbody2D.mass * rotMulty;
				weightResult += diff; 
			} else {
				Debug.Log (string.Format ("Remove : {0}", objectsInContact [i]));
				objectsInContact.Remove (objectsInContact [i]);		
			}
		}



		float frontDivingWaterpoint = OceanHandler.instance.GetHeight (frontDivingPoint.position, true, true);
		float frontUnderWaterAmount = frontDivingPoint.position.y - frontDivingWaterpoint;
		//Debug.Log (string.Format ("frontUnderWaterAmount : {0}", frontUnderWaterAmount));
		if (frontUnderWaterAmount < 0)
			weightResult += frontUnderWaterAmount * divingMultiplyer;


		float backDivingWaterpoint = OceanHandler.instance.GetHeight (backDivingPoint.position, true, true);
		float backUnderWaterAmount = backDivingPoint.position.y - backDivingWaterpoint;
		//Debug.Log (string.Format ("backUnderWaterAmount : {0}", backUnderWaterAmount));
		if (backUnderWaterAmount < 0)
			weightResult -= backUnderWaterAmount * divingMultiplyer;

		if (otherHitsVal != 0) {
			weightResult += otherHitsVal;
			otherHitsVal = 0;
		}
		myFloater.extraWeight = weightResult;
		//weightResult = 0;
	}


	IEnumerator EndFrameClearWeight ()
	{
		
		yield return new WaitForEndOfFrame ();
		weightResult = 0;
	}




	void OnCollisionStay2D (Collision2D coll)
	{
		if (coll.transform.tag == "Player") {
			PlayerControl player = coll.transform.GetComponent <PlayerControl> ();
			if (!objectsInContact.Contains (player))
				objectsInContact.Add (player);
			//float diff = (myTransform.position.x - coll.transform.position.x) * coll.rigidbody.mass * rotMulty;
			//weightResult += diff;
		}
	}

	/*
	void OnCollisionEnter2D (Collision2D coll)
	{
		if (coll.transform.tag == "Player") {

		}
	}


	void OnCollisionExit2D (Collision2D coll)
	{
		if (coll.transform.tag == "Player") {

		}
	}*/

	private Transform _myTransform;

	private Transform myTransform {
		get {
			if (_myTransform == null)
				_myTransform = GetComponent<Transform> ();
			return _myTransform;
		}

		set {
			_myTransform = value;
		}

	}


	private Floater _myFloater;

	private Floater myFloater {
		get {
			if (_myFloater == null)
				_myFloater = GetComponent<Floater> ();
			return _myFloater;
		}   
		set {
			_myFloater = value;
		}
	}

}
