﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class ItemsSpawnHandler : MonoBehaviour
{


	public List<Transform> spawnPositions = new List<Transform> ();

	public List<GameObject> spawnItems = new List<GameObject> ();


	public float spawnIntervals;

	// Use this for initialization
	void Start ()
	{
		StartCoroutine (SpawnItems ());
	}


	IEnumerator SpawnItems ()
	{

		while (!GameController.instance.boatFlipped) {

			float spawnTime = spawnIntervals + Random.Range (-spawnIntervals, spawnIntervals);

			yield return new WaitForSeconds (spawnTime);

			int spawnPosId = Random.Range (0, spawnPositions.Count);
			int spawnItemId = Random.Range (0, spawnItems.Count);

			GameObject newItem = Instantiate (spawnItems [spawnItemId]) as GameObject;
			newItem.SetActive (true);
			Transform newItemTR = newItem.transform;
			newItemTR.position = spawnPositions [spawnPosId].position;
			newItemTR.parent = myTransform.parent;

		}

	}
	
	// Update is called once per frame
	void Update ()
	{
		
	}

	private Transform _myTransform;

	private Transform myTransform {
		get {
			if (_myTransform == null)
				_myTransform = GetComponent<Transform> ();
			return _myTransform;
		}

		set {
			_myTransform = value;
		}

	}

}
