﻿using UnityEngine;
using AudioSystem;
using System.Collections;

/// <summary>
/// Fuzzy movement handler is utility that can bee added to a gameoebjct and have a smooth random movement
/// </summary>
public class FuzzyMovementHandler : MonoBehaviour
{

		[Range (0, 10)]
		public float
				movementAmount;

		[Range (0, 10)]
		public float
				rotationAmount;

		[Range (0, 10)]
		public float
				speed;


		public Vector3 movementAmountVector;
		public Vector3 movementAmountRotVector;


		private Transform _myTransform;

		private Transform myTransform {
				get {
						if (_myTransform == null)
								_myTransform = GetComponent<Transform> ();
						return _myTransform;
				}
		
				set {
						_myTransform = value;
				}
		
		}


		public void FixedUpdate ()
		{
				/*
				float xpos = movementAmount * Mathf.PerlinNoise (Time.time * speed, 0.0F) - movementAmount / 2;
				float zpos = movementAmount * Mathf.PerlinNoise (Time.time * speed, 10.0F) - movementAmount / 2;
				float rot = rotationAmount * Mathf.PerlinNoise (Time.time * speed, 20.0F) - rotationAmount / 2;


				Vector3 newPos = new Vector3 (xpos, 0, zpos);
				Vector3 newRot = new Vector3 (0, rot, 0);

				myTransform.localPosition = newPos;
				myTransform.localRotation = Quaternion.Euler (newRot);
				*/

				float xpos = movementAmountVector.x * Mathf.PerlinNoise (Time.time * speed, 0.0F) - movementAmountVector.x / 2;
				float ypos = movementAmountVector.y * Mathf.PerlinNoise (Time.time * speed, 10.0F) - movementAmountVector.y / 2;
				float zpos = movementAmountVector.z * Mathf.PerlinNoise (Time.time * speed, 20.0F) - movementAmountVector.z / 2;
				
				float xRot = movementAmountRotVector.x * Mathf.PerlinNoise (Time.time * speed, 30.0F) - movementAmountRotVector.x / 2;
				float yRot = movementAmountRotVector.y * Mathf.PerlinNoise (Time.time * speed, 40.0F) - movementAmountRotVector.y / 2;
				float zRot = movementAmountRotVector.z * Mathf.PerlinNoise (Time.time * speed, 50.0F) - movementAmountRotVector.z / 2;


				Vector3 newPos = new Vector3 (xpos, ypos, zpos);
				Vector3 newRot = new Vector3 (xRot, yRot, zRot);

				myTransform.localPosition = newPos;
				myTransform.localRotation = Quaternion.Euler (newRot);
		}

}
